<?php

/**
 * @package     JohnCMS
 * @link        http://johncms.com
 * @copyright   Copyright (C) 2008-2011 JohnCMS Community
 * @license     LICENSE.txt (see attached file)
 * @version     VERSION.txt (see attached file)
 * @author      http://johncms.com/about
 */

define('_IN_JOHNCMS', 1);

require('../incfiles/core.php');
$lng_profile = core::load_lng('profile');

/*
-----------------------------------------------------------------
Закрываем от неавторизованных юзеров
-----------------------------------------------------------------
*/
if (!$user_id) {
    require('../incfiles/head.php');
    echo functions::display_error($lng['access_guest_forbidden']);
    require('../incfiles/end.php');
    exit;
}

/*
-----------------------------------------------------------------
Получаем данные пользователя
-----------------------------------------------------------------
*/
$user = functions::get_user($user);
if (!$user) {
    require('../incfiles/head.php');
    echo functions::display_error($lng['user_does_not_exist']);
    require('../incfiles/end.php');
    exit;
}

/*
-----------------------------------------------------------------
Переключаем режимы работы
-----------------------------------------------------------------
*/
$array = array(
    'activity'  => 'includes/profile',
    'ban'       => 'includes/profile',
    'edit'      => 'includes/profile',
    'images'    => 'includes/profile',
    'info'      => 'includes/profile',
    'ip'        => 'includes/profile',
    'guestbook' => 'includes/profile',
    'karma'     => 'includes/profile',
    'office'    => 'includes/profile',
    'password'  => 'includes/profile',
    'reset'     => 'includes/profile',
    'settings'  => 'includes/profile',
    'stat'      => 'includes/profile',
'friends'   => 'includes/profile',
   'medal'     => 'includes/profile'
);
$path = !empty($array[$act]) ? $array[$act] . '/' : '';
if (array_key_exists($act, $array) && file_exists($path . $act . '.php')) {
    require_once($path . $act . '.php');
} else {
    /*
    -----------------------------------------------------------------
    Анкета пользователя
    -----------------------------------------------------------------
    */
    $headmod = 'profile,' . $user['id'];
$textl = $lng['profile'] . ': ' . htmlspecialchars($user['imname']);
    require('../incfiles/head.php');
if ($user['id'] == $user_id) {
echo '<div class="header"><b>Shaxsiy profil » <a href="/users/profile.php?act=edit&user=' . $user['id'] . '">O‘zgartirish</a></b></div>'; }
if ($user['id'] != core::$user_id) { echo '<div class="header"><b>Foydalanuvchi anketasi</b></div>'; }

    // Меню анкеты
    $menu = array();
    if ($user['id'] == $user_id || $rights == 9 || ($rights == 7 && $rights > $user['rights'])) {
        $menu[] = '<a href="profile.php?act=edit&amp;user=' . $user['id'] . '">' . $lng['edit'] . '</a>';
    }
    if ($user['id'] != $user_id && $rights >= 7 && $rights > $user['rights']) {
        $menu[] = '<a href="' . $set['homeurl'] . '/' . $set['admp'] . '/index.php?act=usr_del&amp;id=' . $user['id'] . '">' . $lng['delete'] . '</a>';
    }
    if ($user['id'] != $user_id && $rights > $user['rights']) {
        $menu[] = '<a href="profile.php?act=ban&amp;mod=do&amp;user=' . $user['id'] . '">' . $lng['ban_do'] . '</a>';
    }
if ($user['rights']) {
$rank = array (
0 => 'Foydalanuvchi',
1 => 'Moderator',
2 => 'Moderator',
3 => 'Moderator',
4 => 'Moderator',
5 => 'Moder',
6 => '<font color="red"><b>Moderator</b></font>',
7 => '<font color="#CC0000"><b>Administrator</b></font>',
9 => '<font color="#CC0000"><b> Sayt yaratuvchisi</b></font>'
); }
$rankk = array(
'lastvisit' => 1,
'iphist' => 1,
'header' => '<br />' . $rank[$user['rights']] . ''
);


echo '<div class="menu1"><p>' . functions::display_user($user, $rankk) . '</p></div>';

    //Уведомление о дне рожденья
    if ($user['dayb'] == date('j', time()) && $user['monthb'] == date('n', time())) {
echo '<div class="menu1">' . $lng['birthday'] . '!!!</div>';
    }



// Меню выбора
if ($user['id'] == $user_id)
{
echo '<div class="menu"><form action="profile.php?act=images&amp;mod=up_photo&amp;user=' . $user['id'] . '" method="post"><input type="submit" value="Rasm o‘rnatish" style="margin-left: 18px"/></form></div>';
}
if ($user['id'] != core::$user_id) {
if (!functions::is_ignor($user['id']) && functions::is_contact($user['id']) != 2 && empty($ban['1']) && empty($ban['3'])) {
echo '<div class="menu"><form action="../mail/index.php?act=write&amp;id=' . $user['id'] . '" method="post"><input type="submit" value="Shaxsiy xabar" style="margin-left: 18px"/></form></div>'; } }


    // Меню выбора
echo '<div class="phdr"><b>Ma\'lumotlar</b></div>';
echo '<div class="menu">';


echo '<p><img style="vertical-align: middle ! important;" src="/images/icon.png" alt="*">Login: '.$user['name_lat'].' <font color="red"><b>(!)</b></font>';
echo '<br/><img style="vertical-align: middle ! important;" src="/images/icon.png" alt="*">Ism: ' . $user['imname'] . '<font color="red"><b> (ID: ' . $user['id'] . ')</b></font><br />';
echo '<img style="vertical-align: middle ! important;" src="/images/icon.png" alt="*">Shahar: ' . $user['live'] . '<br />';


if(!empty($user['yearofbirth'])){
function calc_age($d, $m, $y) {
$age = date('Y') - $y;
$_m = date('m');
if($_m < $m || ($_m == $m && date('d') < $d))
$age--;
return $age; }
$user_age = calc_age($user['dayb'], $user['monthb'], $user['yearofbirth']);
echo '<img style="vertical-align: middle ! important;" src="/images/icon.png" alt="*">Tug‘ilgan sanasi: ' . (empty($user['dayb']) ? '' : sprintf("%02d", $user['dayb']) . '.' . sprintf("%02d", $user['monthb']) . '.' . $user['yearofbirth']) . '  ('.$user_age.' yosh)<br />'; }
echo '<img style="vertical-align: middle ! important;" src="/images/icon.png" alt="*">Ro‘yhatga olingan: ' . date("d.m.Y", $user['datereg']) . '<br />';
echo '<img style="vertical-align: middle ! important;" src="/images/icon.png" alt="*">Oxirgi tashrifi: ' . functions::display_date($user['lastdate']) . '<br />'; echo '</div>'; if ($rights >= 9) {
echo '<div class="menu"><img style="vertical-align: middle ! important;" src="/images/icon.png" alt="*">Browser: ' . $user['browser'] . '<br /></div>'; }

echo '<div class="phdr"><b>Mini statistika</b></div><div class="menu">';
echo '<p>';

$lastvisit = time() > $user['lastdate'] + 300 ? date("d.m.Y | H:i", $user['lastdate']) : true; 
echo '<img style="vertical-align: middle ! important;" src="/images/icon2.png" alt="*"> Saytda bo‘ldi: ' . functions::timecount($user['total_on_site']) . '<br />';

$fikr = mysql_result(mysql_query("SELECT COUNT(*) FROM `cms_news_comments` WHERE `user_id` = '" . $user['id'] . "'"), 0);
echo '<img style="vertical-align: middle ! important;" src="/images/icon2.png" alt="*"> Izohlari: <a href="profile.php?act=activity&amp;mod=comments&amp;user=' . $user['id'] . '"><b>' . $fikr . '</b></a><br />';

      



    $bancount = mysql_result(mysql_query("SELECT COUNT(*) FROM `cms_ban_users` WHERE `user_id` = '" . $user['id'] . "'"), 0);

    if ($bancount) {
echo '<img style="vertical-align: middle ! important;" src="/images/bullet_red.gif" alt="*"> Qoidabuzarliklari: <a href="profile.php?act=ban&amp;user=' . $user['id'] . '"><b>' . $bancount . '</b></a>';
    }

    $total_friends = mysql_result(mysql_query("SELECT COUNT(*) FROM `cms_contact` WHERE `user_id`='{$user['id']}' AND `type`='2' AND `friends`='1'"), 0);



$shxabar = mysql_result(mysql_query("SELECT COUNT(*) FROM `cms_contact` WHERE `user_id`='" . $user_id . "' AND `ban`!='1'"), 0);
$new_chat = mysql_result(mysql_query('select count(*) from `m_chat` where `time` > ' . (time() - 3600*24) . ''), 0);




echo '</div>'; if ($user['id'] == $user_id) {  echo '<div class="phdr"><b>Umumiy sozlamalar</b></div>';
echo '<div class="menu">&raquo; <a href="profile.php?act=edit&amp;user=' . $user['id'] . '">Anketani o‘zgartirish</a><br />';
echo '&raquo; <a href="profile.php?act=password&user=' . $user['id'] . '">Parolni o‘zgartirish</a></div>';
echo '<div class="menu">&raquo; <a href="/mail/">Shaxsiy xabarlar</a>(' . $shxabar . ')<br/>';
echo '&raquo; <a href="/exit.php">Profildan chiqish</a></div>';

} if ($rights >= 9) {     echo '<div class="menu"><img style="vertical-align: middle ! important;" src="/images/bullet_red.gif" alt="*"><a href="profile.php?act=edit&amp;user=' . $user['id'] . '">O‘zgartirish</a> | <a href="profile.php?act=ban&mod=do&user=' . $user['id'] . '">Banlash</a> | <a href="' . $set['homeurl'] . '/' . $set['admp'] . '/index.php?act=usr_del&amp;id=' . $user['id'] . '"> O‘chirish</a>'; } }

   
require_once('../incfiles/end.php');
